Subject: [Netconf] Notification definition in draft-ietf-netconf-restconf-16?

From: "Scharf, Michael (Nokia - DE)" <[email-masked]>
Date: Sat, 17 Sep 2016 12:11:18 +0000

Hi,

I've run into a question on Section 6.4. Receiving Event Notifications in draft-ietf-netconf-restconf-16:

Why uses the I-D a node with the spelling "event-time", instead of "eventTime"? 

I think the schema in RFC 5277 defines the node "eventTime". And there is a MUST in the I-D that requires conformance to the RFC 5277 schema. Do I miss something?

Also, is our understanding correct that the "date-and-time" typedef in RFC 6991 is the suggested encoding?

Thanks

Michael

---

From: Andy Bierman <[email-masked]>
Date: Sun, 18 Sep 2016 17:54:26 -0700

On Sat, Sep 17, 2016 at 5:11 AM, Scharf, Michael (Nokia - DE) <
[email-masked]> wrote:

> I think the schema in RFC 5277 defines the node "eventTime". And there is
> a MUST in the I-D that requires conformance to the RFC 5277 schema. Do I
> miss something?
>

The draft never says what to use for the syntax.
Yes, date-and-time is the correct type and it corresponds to the XSD
"dateTime" type.

You are not missing anything.
You are bringing up an important issue that has been ignored in the draft.
There are gratuitous name and namespace changes in the <notification>
element
that make co-existence with a NETCONF server needlessly complicated.

1) XML namespace changed:

   RFC 5277:  urn:ietf:params:xml:ns:netconf:notification:1.0
RESTCONF: urn:ietf:params:xml:ns:yang:ietf-restconf

2) local-name of event time child element changed

RFC 5277: eventTime
RESTCONF: event-time

IMO there is no justification for these changes.
The <notification> element should use the RFC 5277 encoding.
The JSON encoding will still use "ietf-restconf" as the module name.

> Michael

Andy

>
> _______________________________________________
> Netconf mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/netconf
>

---

From: "Scharf, Michael (Nokia - DE)" <[email-masked]>
Date: Wed, 21 Sep 2016 20:08:37 +0000

So, will the I-D be updated to fix this bug?

Thanks

Michael

From: Andy Bierman [mailto:[email-masked]]
Sent: Monday, September 19, 2016 2:54 AM
To: Scharf, Michael (Nokia - DE)
Cc: [email-masked]
Subject: Re: [Netconf] Notification definition in draft-ietf-netconf-restconf-16?

On Sat, Sep 17, 2016 at 5:11 AM, Scharf, Michael (Nokia - DE) <[email-masked]<mailto:[email-masked]>> wrote:
Hi,

The draft never says what to use for the syntax.
Yes, date-and-time is the correct type and it corresponds to the XSD "dateTime" type.

You are not missing anything.
You are bringing up an important issue that has been ignored in the draft.
There are gratuitous name and namespace changes in the <notification> element
that make co-existence with a NETCONF server needlessly complicated.

RFC 5277: eventTime
RESTCONF: event-time

Thanks

Michael

Andy

_______________________________________________
Netconf mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/netconf

---

From: Martin Bjorklund <[email-masked]>
Date: Wed, 21 Sep 2016 22:28:15 +0200 (CEST)

"Scharf, Michael (Nokia - DE)" <[email-masked]> wrote:
> On Sat, Sep 17, 2016 at 5:11 AM, Scharf, Michael (Nokia - DE)
> <[email-masked]<mailto:[email-masked]>> wrote:
> Hi,
> 
> I think the schema in RFC 5277 defines the node "eventTime". And there
> is a MUST in the I-D that requires conformance to the RFC 5277
> schema. Do I miss something?
> 

Andy, do you mean including RFC 5277 namespace?  If so, I agree we
should do this change.

> The JSON encoding will still use "ietf-restconf" as the module name.

This is also pretty weird.  Implementations that assume that they can
find the 'notification' and 'eventTime' nodes in the module
"ietf-restconf" will fail.  It would probably be better to use a
completely fake module name, e.g. ietf-restconf-notification.

BTW, reading this section, I found another bug.  It says:

  RESTCONF notifications are encoded according to the
  definition of the event stream.  The NETCONF stream
  defined in ^RFC5277^ is encoded in XML format.

But the example in 6.2 shows a server that supports the NETCONF stream
in both xml and json.

I suggest we simply remove the sentence "The NETCONF stream
defined in ^RFC5277^ is encoded in XML format."

/martin

---

From: Andy Bierman <[email-masked]>
Date: Wed, 21 Sep 2016 14:07:48 -0700

Hi,

Yes. I agree this is a bug.
The intent has been all among to reuse RFC 5277

Andy

On Wednesday, September 21, 2016, Scharf, Michael (Nokia - DE) <
[email-masked]> wrote:

> *From:* Andy Bierman [mailto:[email-masked]
> <javascript:_e(%7B%7D,'cvml',[email-masked]');>]
> *Sent:* Monday, September 19, 2016 2:54 AM
> *To:* Scharf, Michael (Nokia - DE)
> *Cc:* [email-masked] <javascript:_e(%7B%7D,'cvml',[email-masked]');>
> *Subject:* Re: [Netconf] Notification definition in
> draft-ietf-netconf-restconf-16?
>
>
>
>
>
>
>
> [email-masked]
> <javascript:_e(%7B%7D,'cvml',[email-masked]');>> wrote:
>
> Hi,
>
> [email-masked] <javascript:_e(%7B%7D,'cvml',[email-masked]');>